
import java.text.MessageFormat;
import java.util.*;


public class GlupaHashMapa extends AbstractMap {
    private LinkedList[] niz;

    public GlupaHashMapa(int n) {
        niz = new LinkedList[n];
        
        for (int i = 0; i < n; i++) {
        	niz[i] = new LinkedList();
        }
    }

    public GlupaHashMapa() {
        this(7);
    }

    public Object put(Object kljuc, Object vrednost) {
        int ind = (kljuc == null) ? 0 : h(kljuc.hashCode());
        Par par = new Par(kljuc, vrednost);

        Object stara = null;
        ListIterator it = niz[ind].listIterator();

        while (it.hasNext()) {
            Object iPar = it.next();

            if (iPar.equals((par))) {
                stara = ((Par) iPar).getValue();
                it.set(par);
                break;
            }
        }
        if (stara == null) {
            niz[ind].add(par);
        }
        return stara;
    }

    public Object get(Object kljuc) {
        int ind = (kljuc == null) ? 0 : h(kljuc.hashCode());
        Par trazeni = new Par(kljuc, null);
        ListIterator it = niz[ind].listIterator();

        while (it.hasNext()) {
            Object iPar = it.next();

            if (iPar.equals((trazeni))) {
                return ((Par) iPar).getValue();
            }
        }
        return null;
    }

    /* Kada se ovo odkomentarise sve je uredu sa metodom remove osim za klju null
	
	
    public Object remove(Object kljuc) {
        int ind = (kljuc == null) ? 0 : h(kljuc.hashCode());
        Par trazeni = new Par(kljuc, null);
        Iterator it = niz[ind].iterator();
        Object stara = null;

        while (it.hasNext()) {
            Object iPar = it.next();

            if (iPar.equals((trazeni))) {
                stara = ((Par) iPar).getValue();

                it.remove();
                break;
            }
        }
        return stara;
    }*/
	
    
    
    /* ovo je slicno uradjeno kao i u AbstractMap ali opet radi brisanje
     
     
     public Object remove(Object kljuc) {
     Iterator it = entrySet().iterator();
     Object stara = null;
     Par trazeni = new Par(kljuc, null);
     
     while (it.hasNext()) {
     Object iPar = it.next();

     if (iPar.equals((trazeni))) {
     stara = ((Par) iPar).getValue();

     System.err.println("pre it.remove()");
     it.remove(); // \\ // Zasto ovo ne radi?
     break;
     }
     }
     return stara;
     }*/		
		
    public Set entrySet() {
        Set elementi = new HashSet();

        for (int i = 0; i < niz.length; i++) {
            if (niz[i].isEmpty()) {
                continue;
            }
            Iterator it = niz[i].iterator();

            while (it.hasNext()) {
                elementi.add(it.next());
            }
        }
        return elementi;
    }

    public String statistikaKolizija() {
        int punInd = niz.length;
        int suma = 0;

        for (int i = 0; i < niz.length; i++) {
            if (niz[i].isEmpty()) {
                punInd--;
            } else {
	            suma += niz[i].size();
        	}
        }

        Object[] rez = {new Integer(suma - punInd), new Integer(punInd),
            	new Integer(niz.length), new Float(1f * punInd / niz.length)};

        return MessageFormat.format(
        		"Broj kolizija: {0, number}\nPopunjenost: {1,number}/{2,number} ({3, number,##.## %})\n",
                rez);
    }

    private int h(int x) {
        return Math.abs(x % niz.length);
    }
}

